Subject: Re: bug#49066: 26.3; Segmentation fault on specific utf8 string

From: Robert Pluim <[email-masked]>
Date: Thu, 17 Jun 2021 09:43:03 +0200

>>>>> On Thu, 17 Jun 2021 09:43:40 +0300, Eli Zaretskii <[email-masked]> said:

    >> I can reproduce the crash in Emacs 26.1, but not in Emacs 27.1, so I
    >> guess this has been fixed in later versions of Emacs?

    Eli> I cannot reproduce at all, neither in Emacs 26 nor in all subsequent
    Eli> versions.

    Eli> Lars, can you show a backtrace from the crash?  Perhaps if I see that,
    Eli> I could tell if it's a known (and fixed) problem.

    Eli> Thanks.

This is from an optimized build of emacs-26.1. I can redo it with a
'-g3 -O0' if you want.

Thread 1 "emacs" received signal SIGSEGV, Segmentation fault.
ftfont_shape_by_flt (matrix=<optimized out>, otf=<optimized out>, ft_face=<optimized out>, font=<optimized out>, lgstring=...)
    at ftfont.c:2573
2573	      g->g.to = LGLYPH_TO (LGSTRING_GLYPH (lgstring, g->g.to));
(gdb) bt
#0  ftfont_shape_by_fltPython Exception <class 'gdb.error'> value has been optimized out: 
 (matrix=<optimized out>, otf=<optimized out>, ft_face=<optimized out>, font=<optimized out>, lgstring=)
    at ftfont.c:2573
#1  ftfont_shapePython Exception <class 'gdb.error'> value has been optimized out: 
 (lgstring=, lgstring@entry=XIL(0xaa2755)) at ftfont.c:2615
#2  0x00000000005d97f5 in xftfont_shape (lgstring=XIL(0xaa2755)) at xftfont.c:670
#3  0x000000000057fc2a in Ffont_shape_gstringPython Exception <class 'gdb.error'> value has been optimized out: 
 (gstring=) at font.c:4427
#4  0x000000000056fede in funcall_subr (subr=0x97fac0 <Sfont_shape_gstring>, numargs=numargs@entry=1, args=args@entry=0x7fffffff59a0)
    at eval.c:2844
#5  0x000000000056ecff in Ffuncall (nargs=<optimized out>, args=args@entry=0x7fffffff5998) at lisp.h:600

Robert
--